color colorMap(float p) {
    int maxVal = 215;
    if (p > 0.5) {
        int r = maxVal;
        int g = maxVal - int((p - 0.5) * 2 * maxVal);
        return color(r, g, 120);
    } else {
        int r = int(sin(PI * p) * maxVal);
        int g = maxVal;
        return color(r, g, 120);
    }
}

int[] gradientGen(int[] arr) {
    // first find max and min
    int arr_len = arr.length;
    int min = 123456789, max = 0;
    for (int i = 0; i < arr_len; ++i) {
        if (arr[i] > max) {
            max = arr[i];
        }
        if (arr[i] < min) {
            min = arr[i];
        }
    }
    return gradientGen(arr, min, max);
}

int[] gradientGen(int[] arr, int min, int max) {
    // count occurence of values
    int arr_len = arr.length;
    int[] count = new int[max - min + 1];
    int count_len = count.length;
    for (int i = 0; i < count_len; ++i) {
        count[i] = 0;
    }
    for (int i = 0; i < arr_len; ++i) {
        count[arr[i] - min] += 1;
    }
    // integral values and normalize to 255
    for (int i = 1; i < count_len; ++i) {
        count[i] += count[i-1];
    }
    for (int i = 0; i < count_len; ++i) {
        count[i] = Math.round((float)count[i] / arr_len * 255);
        // avg with flat curve to prevent extreme exaggeration
        count[i] = round(0.5 * (count[i] + 255 * (float)i / (count_len - 1)));
    }
    return count;
}

color getGradient(float p, color[] colors, int[] curve) {
    // p: float btwn 0~1, relative position of data in min~max range
    // newp: p mapped by curve
    int curve_length = curve.length - 1;
    int curve_idx = floor(p * curve_length);
    float newp = curve[curve_idx] / 255.0;
    // return color(curve[curve_idx]);

    int num_color = colors.length;
    int color_range_start = 0;
    for (int i = 1; i < num_color; ++i) {
        if (newp <= (float)i / (num_color - 1)) {
            color_range_start = i - 1;
            break;
        }
    }
    // k: relative position btwn color range start and end
    // k = (p - start) / range length
    float range_length = 1.0 / (num_color - 1);
    float k = (newp - color_range_start * range_length) / range_length;
    color c = lerpColor(colors[color_range_start], colors[color_range_start + 1], k);
    return c;
}
